Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization.Views/3.3/ShapeInfoExtensions.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization.Views/3.3/ShapeInfoExtensions.cs	(revision 6036)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization.Views/3.3/ShapeInfoExtensions.cs	(revision 6036)
@@ -0,0 +1,115 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using Netron.Diagramming.Core;
+
+namespace HeuristicLab.Operators.Views.GraphVisualization.Views {
+  internal static class ShapeInfoExtensions {
+    public static IShape CreateShape(this IShapeInfo shapeInfo) {
+      if (shapeInfo is IOperatorShapeInfo) return CreateShape((IOperatorShapeInfo)shapeInfo);
+      throw new ArgumentException("Could not determine which shape object should be created.");
+    }
+
+    public static void UpdateShape(this IShapeInfo shapeInfo, IShape shape) {
+      shape.Location = shapeInfo.Location;
+      if (shapeInfo is IOperatorShapeInfo && shape is OperatorShape)
+        UpdateShape((IOperatorShapeInfo)shapeInfo, (OperatorShape)shape);
+    }
+
+    public static void UpdateShapeInfo(this IShapeInfo shapeInfo, IShape shape) {
+      shapeInfo.Location = shape.Location;
+      if (shapeInfo is IOperatorShapeInfo && shape is OperatorShape)
+        UpdateShapeInfo((IOperatorShapeInfo)shapeInfo, (OperatorShape)shape);
+    }
+
+    #region OperatorShapeInfo specific methos
+    public static OperatorShape CreateShape(IOperatorShapeInfo shapeInfo) {
+      OperatorShape shape = new OperatorShape();
+      shape.Tag = shapeInfo;
+      shape.Location = shapeInfo.Location;
+      shape.Title = shapeInfo.Title;
+      shape.Color = shapeInfo.Color;
+      shape.LineColor = shapeInfo.LineColor;
+      shape.LineWidth = shapeInfo.LineWidth;
+      shape.Icon = shapeInfo.Icon;
+      shape.Collapsed = shapeInfo.Collapsed;
+      foreach (string connectorName in shapeInfo.Connectors)
+        if (connectorName != OperatorShapeInfoFactory.SuccessorConnector && connectorName != OperatorShapeInfoFactory.PredecessorConnector)
+          shape.AddConnector(connectorName);
+
+      shape.UpdateLabels(shapeInfo.Labels);
+      return shape;
+    }
+
+    public static void UpdateShape(IOperatorShapeInfo operatorShapeInfo, OperatorShape operatorShape) {
+      operatorShape.Title = operatorShapeInfo.Title;
+      operatorShape.Color = operatorShapeInfo.Color;
+      operatorShape.LineColor = operatorShapeInfo.LineColor;
+      operatorShape.LineWidth = operatorShapeInfo.LineWidth;
+      operatorShape.Icon = operatorShapeInfo.Icon;
+      operatorShape.Collapsed = operatorShapeInfo.Collapsed;
+
+      int i = 0;
+      int j = 0;
+      //remove old connectors and skip correct connectors
+      List<string> oldConnectorNames = operatorShape.AdditionalConnectorNames.ToList();
+      while (i < operatorShapeInfo.Connectors.Count() && j < oldConnectorNames.Count) {
+        if (operatorShapeInfo.Connectors.ElementAt(i) == OperatorShapeInfoFactory.SuccessorConnector ||
+          operatorShapeInfo.Connectors.ElementAt(i) == OperatorShapeInfoFactory.PredecessorConnector)
+          i++;
+        else if (oldConnectorNames[j] == OperatorShapeInfoFactory.SuccessorConnector ||
+          oldConnectorNames[j] == OperatorShapeInfoFactory.PredecessorConnector)
+          j++;
+        else if (operatorShapeInfo.Connectors.ElementAt(i) != oldConnectorNames[j]) {
+          operatorShape.RemoveConnector(oldConnectorNames[j]);
+          j++;
+        } else {
+          i++;
+          j++;
+        }
+      }
+      //remove remaining old connectors
+      for (; j < oldConnectorNames.Count; j++)
+        operatorShape.RemoveConnector(oldConnectorNames[j]);
+
+      //add new connectors except successor and connector
+      for (; i < operatorShapeInfo.Connectors.Count(); i++)
+        if (operatorShapeInfo.Connectors.ElementAt(i) != OperatorShapeInfoFactory.SuccessorConnector &&
+          operatorShapeInfo.Connectors.ElementAt(i) != OperatorShapeInfoFactory.PredecessorConnector)
+          operatorShape.AddConnector(operatorShapeInfo.Connectors.ElementAt(i));
+
+      operatorShape.UpdateLabels(operatorShapeInfo.Labels);
+    }
+
+    public static void UpdateShapeInfo(IOperatorShapeInfo operatorShapeInfo, OperatorShape operatorShape) {
+      operatorShapeInfo.Title = operatorShape.Title;
+      operatorShapeInfo.Color = operatorShape.Color;
+      operatorShapeInfo.LineColor = operatorShape.LineColor;
+      operatorShapeInfo.LineWidth = operatorShape.LineWidth;
+      operatorShapeInfo.Icon = operatorShape.Icon;
+      operatorShapeInfo.Collapsed = operatorShape.Collapsed;
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IShapeInfo.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IShapeInfo.cs	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IShapeInfo.cs	(revision 6036)
@@ -24,15 +24,9 @@
 using System.Drawing;
 using HeuristicLab.Common;
-using Netron.Diagramming.Core;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
   public interface IShapeInfo : IDeepCloneable {
-    Type ShapeType { get; }
     Point Location { get; set; }
-
-    IShape CreateShape();
     IEnumerable<string> Connectors { get; }
-    void UpdateShape(IShape shape);
-    void UpdateShapeInfo(IShape shape);
 
     event EventHandler Changed;
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/ShapeInfo.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/ShapeInfo.cs	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/ShapeInfo.cs	(revision 6036)
@@ -25,5 +25,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using Netron.Diagramming.Core;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
@@ -34,19 +33,8 @@
     protected ShapeInfo(ShapeInfo original, Cloner cloner)
       : base(original, cloner) {
-      shapeType = original.shapeType;
       location = original.location;
     }
 
-    protected ShapeInfo(Type shapeType) {
-      if (!typeof(IShape).IsAssignableFrom(shapeType))
-        throw new ArgumentException("The passed shape type " + shapeType + " must be derived from IShape.");
-      this.shapeType = shapeType;
-    }
-
-    [Storable]
-    private Type shapeType;
-    public Type ShapeType {
-      get { return this.shapeType; }
-    }
+    protected ShapeInfo() : base() { }
 
     [Storable]
@@ -69,19 +57,4 @@
       if (handler != null) this.Changed(this, EventArgs.Empty);
     }
-
-    public virtual IShape CreateShape() {
-      IShape shape = (IShape)Activator.CreateInstance(this.shapeType);
-      shape.Tag = this;
-      shape.Location = this.Location;
-      return shape;
-    }
-
-    public virtual void UpdateShape(IShape shape) {
-      shape.Location = this.Location;
-    }
-
-    public virtual void UpdateShapeInfo(IShape shape) {
-      this.Location = shape.Location;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLab.Operators.Views.GraphVisualization-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLab.Operators.Views.GraphVisualization-3.3.csproj	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLab.Operators.Views.GraphVisualization-3.3.csproj	(revision 6036)
@@ -12,5 +12,6 @@
     <AssemblyName>HeuristicLab.Operators.Views.GraphVisualization-3.3</AssemblyName>
     <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
-    <TargetFrameworkProfile></TargetFrameworkProfile>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
     <FileAlignment>512</FileAlignment>
     <SignAssembly>true</SignAssembly>
@@ -112,4 +113,6 @@
   <ItemGroup>
     <Compile Include="HeuristicLabOperatorsViewsGraphVisualizationPlugin.cs" />
+    <Compile Include="OperatorGraphVisualization\OperatorShape.cs" />
+    <Compile Include="OperatorGraphVisualization\OperatorShapeInfoFactory.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
@@ -119,20 +122,8 @@
     <None Include="Properties\AssemblyInfo.frame" />
     <Compile Include="General\GraphVisualizationInfo.cs" />
-    <Compile Include="General\GraphVisualizationInfoView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="General\GraphVisualizationInfoView.Designer.cs">
-      <DependentUpon>GraphVisualizationInfoView.cs</DependentUpon>
-    </Compile>
     <Compile Include="General\ConnectionInfo.cs" />
     <Compile Include="General\IConnectionInfo.cs" />
     <Compile Include="General\IGraphVisualizationInfo.cs" />
     <Compile Include="OperatorGraphVisualization\IOperatorShapeInfo.cs" />
-    <Compile Include="OperatorGraphVisualization\OperatorGraphView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="OperatorGraphVisualization\OperatorGraphView.Designer.cs">
-      <DependentUpon>OperatorGraphView.cs</DependentUpon>
-    </Compile>
     <Compile Include="OperatorGraphVisualization\OperatorGraphVisualizationInfo.cs">
       <SubType>Code</SubType>
@@ -141,9 +132,7 @@
     <Compile Include="BidirectionalLookup.cs" />
     <Compile Include="General\IShapeInfo.cs" />
-    <Compile Include="OperatorGraphVisualization\OperatorShape.cs" />
     <Compile Include="General\ShapeInfo.cs">
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="OperatorGraphVisualization\OperatorShapeInfoFactory.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -152,15 +141,7 @@
       <Name>HeuristicLab.Collections-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.3\HeuristicLab.Common.Resources-3.3.csproj">
-      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
-      <Name>HeuristicLab.Common.Resources-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
       <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
       <Name>HeuristicLab.Common-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
-      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
-      <Name>HeuristicLab.Core.Views-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
@@ -168,35 +149,7 @@
       <Name>HeuristicLab.Core-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.ExtLibs\HeuristicLab.Netron\3.0.2672.12446\HeuristicLab.Netron-3.0.2672.12446\HeuristicLab.Netron-3.0.2672.12446.csproj">
-      <Project>{BB994448-2B21-4564-BB2E-38D8FFF8CF18}</Project>
-      <Name>HeuristicLab.Netron-3.0.2672.12446 %28HeuristicLab.ExtLibs\HeuristicLab.Netron\HeuristicLab.Netron-3.0.2672.12446\HeuristicLab.Netron-3.0.2672.12446%29</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.ExtLibs\HeuristicLab.Netron\3.0.2672.12446\Netron.Diagramming.Core-3.0.2672.12446\Netron.Diagramming.Core-3.0.2672.12446.csproj">
-      <Project>{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}</Project>
-      <Name>Netron.Diagramming.Core-3.0.2672.12446</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
-      <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
-      <Name>HeuristicLab.MainForm.WindowsForms-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
-      <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
-      <Name>HeuristicLab.MainForm-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Operators.Views\3.3\HeuristicLab.Operators.Views-3.3.csproj">
-      <Project>{C49CB749-8B24-4628-8003-E86475749410}</Project>
-      <Name>HeuristicLab.Operators.Views-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
       <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
       <Name>HeuristicLab.Operators-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Optimizer\3.3\HeuristicLab.Optimizer-3.3.csproj">
-      <Project>{C664305E-497C-4533-A140-967DEDB05C19}</Project>
-      <Name>HeuristicLab.Optimizer-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
-      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
-      <Name>HeuristicLab.Parameters-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLabOperatorsViewsGraphVisualizationPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLabOperatorsViewsGraphVisualizationPlugin.cs.frame	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLabOperatorsViewsGraphVisualizationPlugin.cs.frame	(revision 6036)
@@ -33,9 +33,5 @@
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.Netron", "3.0")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabOperatorsViewsGraphVisualizationPlugin : PluginBase {
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/IOperatorShapeInfo.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/IOperatorShapeInfo.cs	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/IOperatorShapeInfo.cs	(revision 6036)
@@ -35,4 +35,5 @@
     void RemoveConnector(string connectorName);
 
+    IEnumerable<string> Labels { get; }
     void UpdateLabels(IEnumerable<string> labels);
   }
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphVisualizationInfo.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphVisualizationInfo.cs	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphVisualizationInfo.cs	(revision 6036)
@@ -128,5 +128,5 @@
     }
 
-    internal IOperator GetOperatorForShapeInfo(IOperatorShapeInfo shapeInfo) {
+    public IOperator GetOperatorForShapeInfo(IOperatorShapeInfo shapeInfo) {
       return this.operatorShapeInfoMapping.GetBySecond(shapeInfo);
     }
@@ -192,5 +192,5 @@
 
     #region methods to manipulate operatorgraph by the shape info
-    internal void AddShapeInfo(IOperator op, IOperatorShapeInfo shapeInfo) {
+    public void AddShapeInfo(IOperator op, IOperatorShapeInfo shapeInfo) {
       this.RegisterOperatorEvents(op);
       this.operatorParameterCollectionMapping.Add(op, op.Parameters);
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShape.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShape.cs	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShape.cs	(revision 6036)
@@ -20,262 +20,12 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Drawing;
-using System.Drawing.Drawing2D;
-using System.Linq;
-using HeuristicLab.Netron;
-using Netron.Diagramming.Core;
 
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
-  public class OperatorShape : ComplexShapeBase {
-    private static int LABEL_HEIGHT = 16;
-    private static int LABEL_WIDTH = 180;
-    private static int LABEL_SPACING = 3;
-    private int headerHeight = 30;
-
-    private ExpandableIconMaterial expandIconMaterial;
-    public OperatorShape()
-      : base() {
-      this.Resizable = false;
-      this.additionalConnectors = new List<IConnector>();
-      this.labels = new List<string>();
-    }
-
-    public override string EntityName {
-      get { return "Operator Shape"; }
-    }
-
-    public bool Collapsed {
-      get { return this.expandIconMaterial.Collapsed; }
-      set {
-        if (this.expandIconMaterial.Collapsed != value)
-          this.expandIconMaterial.Collapsed = value;
-      }
-    }
-
-    private Color lineColor;
-    public Color LineColor {
-      get { return this.lineColor; }
-      set { this.lineColor = value; }
-    }
-
-    private float lineWidth;
-    public float LineWidth {
-      get { return this.lineWidth; }
-      set { this.lineWidth = value; }
-    }
-
-    private Color color;
-    public Color Color {
-      get { return this.color; }
-      set { this.color = value; }
-    }
-
-    private string title;
-    public string Title {
-      get { return title; }
-      set { title = value; }
-    }
-
-    private IconMaterial iconMaterial;
-    public Bitmap Icon {
-      get { return this.iconMaterial.Icon; }
-      set {
-        this.iconMaterial.Icon = value;
-        this.iconMaterial.Transform(new Rectangle(new Point(Rectangle.X + 5, Rectangle.Y + 5), this.iconMaterial.Icon.Size));
-      }
-    }
-
-    #region additional connectors
-    private List<IConnector> additionalConnectors;
-    public IEnumerable<string> AdditionalConnectorNames {
-      get { return this.additionalConnectors.Select(c => c.Name); }
-    }
-
-    private IConnector predecessor;
-    public IConnector Predecessor {
-      get { return this.predecessor; }
-    }
-
-    private IConnector successor;
-    public IConnector Successor {
-      get { return this.successor; }
-    }
-
-    private IConnector CreateConnector(string connectorName, Point location) {
-      Connector connector = new Connector(location, this.Model);
-      connector.ConnectorStyle = ConnectorStyle.Square;
-      connector.Parent = this;
-      connector.Name = connectorName;
-      return connector;
-    }
-
-    public void AddConnector(string connectorName) {
-      IConnector connector = this.CreateConnector(connectorName, this.BottomRightCorner);
-
-      this.additionalConnectors.Add(connector);
-      this.Connectors.Add(connector);
-      this.UpdateConnectorLocation();
-    }
-
-    public void RemoveConnector(string connectorName) {
-      IConnector connector = this.additionalConnectors.Where(c => c.Name == connectorName).FirstOrDefault();
-      if (connector != null) {
-        this.additionalConnectors.Remove(connector);
-        this.Connectors.Remove(connector);
-        this.UpdateConnectorLocation();
-      }
-    }
-
-    private void UpdateConnectorLocation() {
-      if (this.additionalConnectors.Count == 0)
-        return;
-
-      int spacing = this.Rectangle.Width / this.additionalConnectors.Count;
-      int margin = spacing / 2;
-      int posX = margin + this.Rectangle.X;
-      for (int i = 0; i < this.additionalConnectors.Count; i++) {
-        this.additionalConnectors[i].MoveBy(new Point(posX - this.additionalConnectors[i].Point.X, 0));
-        posX += spacing;
-      }
-    }
-    #endregion
-
-    #region label material
-    private List<string> labels;
-    public IEnumerable<string> Labels {
-      get { return this.labels; }
-    }
-
-    public void UpdateLabels(IEnumerable<string> labels) {
-      this.labels = new List<string>(labels);
-      this.expandIconMaterial.Visible = this.labels.Count != 0;
-      this.UpdateLabels();
-    }
-    #endregion
-
-    private void expandIconMaterial_OnExpand(object sender, EventArgs e) {
-      this.UpdateLabels();
-    }
-
-    private void expandIconMaterial_OnCollapse(object sender, EventArgs e) {
-      this.UpdateLabels();
-    }
-
-    private Size CalculateSize() {
-      int width = this.Rectangle.Width;
-      int height = headerHeight;
-      if (!Collapsed)
-        height += this.labels.Count * (LABEL_HEIGHT + LABEL_SPACING);
-      return new Size(width, height);
-    }
-
-    private void UpdateLabels() {
-      Size newSize = CalculateSize();
-      if (this.Rectangle.Size != newSize) {
-        foreach (IConnector connector in this.additionalConnectors)
-          connector.MoveBy(new Point(0, newSize.Height - this.Rectangle.Height));
-        this.mRectangle = new Rectangle(this.Rectangle.Location, newSize);
-        this.Invalidate();
-        this.RaiseOnChange(this, new EntityEventArgs(this));
-      }
-    }
-
-    protected override void Initialize() {
-      base.Initialize();
-
-      //the initial size
-      this.Transform(0, 0, 200, headerHeight);
-      this.color = Color.LightBlue;
-
-      this.iconMaterial = new IconMaterial();
-      this.iconMaterial.Gliding = false;
-      this.Children.Add(iconMaterial);
-
-      Bitmap expandBitmap = new Bitmap(HeuristicLab.Common.Resources.VSImageLibrary.Expand);
-      Bitmap collapseBitmap = new Bitmap(HeuristicLab.Common.Resources.VSImageLibrary.Collapse);
-      this.expandIconMaterial = new ExpandableIconMaterial(expandBitmap, collapseBitmap);
-      this.expandIconMaterial.Gliding = false;
-      this.expandIconMaterial.Transform(new Rectangle(new Point(Rectangle.Right - 20, Rectangle.Y + 7), expandIconMaterial.Icon.Size));
-      this.expandIconMaterial.Visible = false;
-      this.expandIconMaterial.OnExpand += new EventHandler(expandIconMaterial_OnExpand);
-      this.expandIconMaterial.OnCollapse += new EventHandler(expandIconMaterial_OnCollapse);
-      this.Children.Add(expandIconMaterial);
-
-      this.predecessor = this.CreateConnector(OperatorShapeInfoFactory.PredecessorConnector, new Point(Rectangle.Left, Center.Y));
-      this.Connectors.Add(predecessor);
-
-      this.successor = this.CreateConnector(OperatorShapeInfoFactory.SuccessorConnector, (new Point(Rectangle.Right, Center.Y)));
-      this.Connectors.Add(successor);
-    }
-
-    public override void Paint(Graphics g) {
-      base.Paint(g);
-
-      g.SmoothingMode = SmoothingMode.HighQuality;
-
-      Pen pen = new Pen(lineColor, lineWidth);
-
-      SizeF titleSize = g.MeasureString(this.Title, ArtPalette.DefaultBoldFont, Rectangle.Width - 45);
-      if (titleSize.Height + 10 > Rectangle.Height) {
-        headerHeight = (int)titleSize.Height + 10;
-        this.UpdateLabels();
-      }
-
-      GraphicsPath path = new GraphicsPath();
-      path.AddArc(Rectangle.X, Rectangle.Y, 20, 20, -180, 90);
-      path.AddLine(Rectangle.X + 10, Rectangle.Y, Rectangle.X + Rectangle.Width - 10, Rectangle.Y);
-      path.AddArc(Rectangle.X + Rectangle.Width - 20, Rectangle.Y, 20, 20, -90, 90);
-      path.AddLine(Rectangle.X + Rectangle.Width, Rectangle.Y + 10, Rectangle.X + Rectangle.Width, Rectangle.Y + Rectangle.Height - 10);
-      path.AddArc(Rectangle.X + Rectangle.Width - 20, Rectangle.Y + Rectangle.Height - 20, 20, 20, 0, 90);
-      path.AddLine(Rectangle.X + Rectangle.Width - 10, Rectangle.Y + Rectangle.Height, Rectangle.X + 10, Rectangle.Y + Rectangle.Height);
-      path.AddArc(Rectangle.X, Rectangle.Y + Rectangle.Height - 20, 20, 20, 90, 90);
-      path.AddLine(Rectangle.X, Rectangle.Y + Rectangle.Height - 10, Rectangle.X, Rectangle.Y + 10);
-      //shadow
-      if (ArtPalette.EnableShadows) {
-        Region darkRegion = new Region(path);
-        darkRegion.Translate(5, 5);
-        g.FillRegion(ArtPalette.ShadowBrush, darkRegion);
-      }
-      //background
-      g.FillPath(Brush, path);
-
-      using (LinearGradientBrush gradientBrush = new LinearGradientBrush(Rectangle.Location, new Point(Rectangle.X + Rectangle.Width, Rectangle.Y), this.Color, Color.White)) {
-        Region gradientRegion = new Region(path);
-        g.FillRegion(gradientBrush, gradientRegion);
-      }
-
-      if (!this.Collapsed) {
-        TextStyle textStyle = new TextStyle(Color.Black, new Font("Arial", 7), StringAlignment.Near, StringAlignment.Near);
-        StringFormat stringFormat = textStyle.StringFormat;
-        stringFormat.Trimming = StringTrimming.EllipsisWord;
-        stringFormat.FormatFlags = StringFormatFlags.LineLimit;
-        Rectangle rect;
-
-        for (int i = 0; i < this.labels.Count; i++) {
-          rect = new Rectangle(Rectangle.X + 25, Rectangle.Y + headerHeight + i * (LABEL_HEIGHT + LABEL_SPACING), LABEL_WIDTH, LABEL_HEIGHT);
-          g.DrawString(textStyle.GetFormattedText(this.labels[i]), textStyle.Font, textStyle.GetBrush(), rect, stringFormat);
-        }
-      }
-
-      //the border
-      g.DrawPath(pen, path);
-
-      //the title
-      g.DrawString(this.Title, ArtPalette.DefaultBoldFont, Brushes.Black, new Rectangle(Rectangle.X + 25, Rectangle.Y + 5, Rectangle.Width - 45, Rectangle.Height - 5));
-
-
-      //the material
-      foreach (IPaintable material in Children)
-        material.Paint(g);
-
-      //the connectors
-      if (this.ShowConnectors) {
-        for (int k = 0; k < Connectors.Count; k++)
-          Connectors[k].Paint(g);
-      }
-    }
+  internal class OperatorShape {
+    //21.04.2011 mkommend
+    //Do not delete this empty class, because this type was moved in to the plugin GraphVisualiation.Views
+    //But it is referenced in persisted ShapeInfo objects and thus these files could not be loaded without this type
+    //Should be removed with HL 3.4
   }
 }
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfo.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfo.cs	(revision 6035)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShapeInfo.cs	(revision 6036)
@@ -22,14 +22,15 @@
 using System.Collections.Generic;
 using System.Drawing;
-using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using Netron.Diagramming.Core;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
   [StorableClass]
-  internal class OperatorShapeInfo : ShapeInfo, IOperatorShapeInfo {
+  public class OperatorShapeInfo : ShapeInfo, IOperatorShapeInfo {
     [Storable]
     private List<string> labels;
+    public IEnumerable<string> Labels {
+      get { return labels; }
+    }
 
     private object lockObject = new object();
@@ -61,5 +62,5 @@
 
     public OperatorShapeInfo()
-      : base(typeof(OperatorShape)) {
+      : base() {
       this.connectorNames = new List<string>();
       this.labels = new List<string>();
@@ -173,72 +174,4 @@
       }
     }
-
-    public override IShape CreateShape() {
-      OperatorShape shape = (OperatorShape)base.CreateShape();
-      shape.Title = this.Title;
-      shape.Color = this.Color;
-      shape.LineColor = this.LineColor;
-      shape.LineWidth = this.LineWidth;
-      shape.Icon = this.Icon;
-      shape.Collapsed = this.Collapsed;
-      foreach (string connectorName in this.connectorNames)
-        if (connectorName != OperatorShapeInfoFactory.SuccessorConnector && connectorName != OperatorShapeInfoFactory.PredecessorConnector)
-          shape.AddConnector(connectorName);
-
-      shape.UpdateLabels(this.labels);
-      return shape;
-    }
-
-    public override void UpdateShape(IShape shape) {
-      base.UpdateShape(shape);
-      OperatorShape operatorShape = (OperatorShape)shape;
-      operatorShape.Title = this.Title;
-      operatorShape.Color = this.Color;
-      operatorShape.LineColor = this.LineColor;
-      operatorShape.LineWidth = this.LineWidth;
-      operatorShape.Icon = this.Icon;
-      operatorShape.Collapsed = this.Collapsed;
-
-      int i = 0;
-      int j = 0;
-      //remove old connectors and skip correct connectors
-      List<string> oldConnectorNames = operatorShape.AdditionalConnectorNames.ToList();
-      while (i < this.connectorNames.Count && j < oldConnectorNames.Count) {
-        if (connectorNames[i] == OperatorShapeInfoFactory.SuccessorConnector ||
-          connectorNames[i] == OperatorShapeInfoFactory.PredecessorConnector)
-          i++;
-        else if (oldConnectorNames[j] == OperatorShapeInfoFactory.SuccessorConnector ||
-          oldConnectorNames[j] == OperatorShapeInfoFactory.PredecessorConnector)
-          j++;
-        else if (this.connectorNames[i] != oldConnectorNames[j]) {
-          operatorShape.RemoveConnector(oldConnectorNames[j]);
-          j++;
-        } else {
-          i++;
-          j++;
-        }
-      }
-      //remove remaining old connectors
-      for (; j < oldConnectorNames.Count; j++)
-        operatorShape.RemoveConnector(oldConnectorNames[j]);
-
-      //add new connectors except successor and connector
-      for (; i < this.connectorNames.Count; i++)
-        if (this.connectorNames[i] != OperatorShapeInfoFactory.SuccessorConnector && this.connectorNames[i] != OperatorShapeInfoFactory.PredecessorConnector)
-          operatorShape.AddConnector(this.connectorNames[i]);
-
-      operatorShape.UpdateLabels(this.labels);
-    }
-
-    public override void UpdateShapeInfo(IShape shape) {
-      base.UpdateShapeInfo(shape);
-      OperatorShape operatorShape = (OperatorShape)shape;
-      this.Title = operatorShape.Title;
-      this.Color = operatorShape.Color;
-      this.LineColor = operatorShape.LineColor;
-      this.LineWidth = operatorShape.LineWidth;
-      this.Icon = operatorShape.Icon;
-      this.Collapsed = operatorShape.Collapsed;
-    }
   }
 }
